A YANG Network Data Model of Network Inventory Software Extensions
Bo Wu
Huawei
101 Software Avenue, Yuhua District
Nanjing
Jiangsu
210012
China
lana.wubo@huawei.com
Cheng Zhou
China Mobile
Beijing
100053
China
zhouchengyjy@chinamobile.com
Qin Wu
Huawei
101 Software Avenue, Yuhua District
Nanjing
Jiangsu
210012
China
bill.wu@huawei.com
Mohamed Boucadair
Orange
Rennes 35000
France
mohamed.boucadair@orange.com
2024
OPS Area
IVY
Network Inventory Software
The base Network Inventory YANG model defines the physical network elements (NEs) and hardware components of NEs. This document extends the base Network Inventory model for non-physical NEs (e.g., controllers, virtual routers, virtual firewalls) and software components (e.g., platform operating system (OS), software-patch).

Introduction
The Network Inventory consists of the physical and non-physical network elements (NEs), hardware components, firmware components, and software components on the a managed network domain. The non-physical network elements (NEs) are network devices that support network protocols and functions, e.g., routers, firewalls, and controllers, which can reside in any network or compute devices, such as servers in Data Center (DC), server-based virtual machines (VMs), or server-based containers.
[I-D.ietf-ivy-network-inventory-yang] defines the base Network Inventory YANG model for physical network element (NE) and hardware components of NEs. Examples of hardware components could be rack, shelf, slot, board and physical port.
The management of non-physical NE and software components information is similar to the management of physical NE and hardware information. For example, inventory data, including product names, serial numbers, etc. are also applicable. This document defines a network inventory software extension YANG model. In addition to inheriting the common inventory attributes of the base network inventory model, this document also adds some software-specific attributes of non-physical NEs (such as controllers, virtual routers, and virtual firewalls) and software components (such as operating system, software patches, BIOS, and boot loader).
The Network Inventory software extension model is classified as a network model (Section 4 of [RFC8309]).
The YANG data model in Section 7 conforms to the Network Management Datastore Architecture (NMDA) [RFC8342].

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119][RFC8174] when, and only when, they appear in all capitals, as shown here.

Relationship to Other YANG Data Models
The base network inventory model supports the software versions of NEs and software versions of hardware components. This document adds more software component identifiers (e.g. platformos, software patch) and more NE types (e.g. software NE, virtual NE) to provide enhanced software information on the NE to facilitate software compatibility check.
Figure 1 depicts the relationship between the Software Extension model and other models. The Software Extension network inventory model enhances the model defined in the base network inventory model with more software specific attributes.

Relationship of SW Extension Model to Other Inventory Models
   +-------------------------+
   |                         |
   | Base Network Inventory  |
   |                         |
   +------------+------------+
                |
        +-------+-------+
        |               |
 +------V------+ +------V------+  +-------------+
 |             | |             |  |             |
 | Hardware    | |  Software   |  |             |
 | Extensions  | |  Extensions |  | Entitlement |
 | e.g. Power  | |  e.g.       |  |             |
 | supply unit | |  SW patch   |  |             |
 +-------------+ +-------------+  +-------------+

Model Overview
The following tree diagram [RFC8340] provides an overview of the data model for "ietf-network-inventory-sw-ext" module.
module: ietf-network-inventory-sw-ext
  augment /nwi:network-inventory/nwi:network-elements
            /nwi:network-element:
    +--ro software-attributes
       +--ro status?              identityref
       +--ro installation-time?   yang:date-and-time
       +--ro activation-time?     yang:date-and-time
  augment /nwi:network-inventory/nwi:network-elements
            /nwi:network-element/nwi:components/nwi:component:
    +--ro software-module-attributes
       +--ro status?              identityref
       +--ro installation-time?   yang:date-and-time
       +--ro activation-time?     yang:date-and-time

Non-physical Network Elements
In the base Network Inventory YANG model, "ne-type" is a YANG identity that describes the type of the network element and only the "physical-network-element" identity" is defined. This document adds non-physical NE identity, such as "ne-software", "ne-virtual", and "ne-container".
The base Network Inventory model also defines common inventory attributes, including the software version, patch versions, product name, and serial number. The data is also applicable to non-physical NEs.
The Network Inventory software extension mode defines some new software attributes, consisting of software status, installation time, and activation time.

Software components
Software components refer to the softwares installed on the NE, such as operating system, software patches, BIOS, and boot loaders.
Similar to the common inventory attributes of NEs, the common attributes of software components (such as software version, patch versions, product name, and serial number) are also applicable to software components. For software and patch versions, the base inventory (Section 4 of [I-D.ietf-ivy-network-inventory-yang]) defines the "leaf" of "software-rev" and the "leaf-list" of "software-patch-rev". If more detailed installation and activation information is needed, the extension attributes of software components can be used.

YANG Data model for Network Inventory Software Extensions
The "ietf-network-inventory-sw-ext" module uses types defined in xxxx.
<CODE BEGINS> file="ietf-network-inventory-sw-ext@2024-10-17.yang"
module ietf-network-inventory-sw-ext {
  yang-version 1.1;
  namespace
    "urn:ietf:params:xml:ns:yang:ietf-network-inventory-sw-ext";
  prefix nwis;

  import ietf-yang-types {
    prefix yang;
    reference
      "RFC 6991: Common YANG Data Types";
  }
  import ietf-network-inventory {
    prefix nwi;
    reference
      "RFCAAAA: A YANG Data Model for Network Inventory";
  }

  organization
    "IETF Network Inventory YANG (ivy) Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/ivy>
     WG List:  <mailto:inventory-yang@ietf.org>

     Editor: Bo Wu
             <lana.wubo@huawei.com>
     Editor: Cheng Zhou
          <zhouchengyjy@chinamobile.com>
     Editor: Qin Wu
             <bill.wu@huawei.com>
     Editor: Mohamed Boucadair
             <mohamed.boucadair@orange.com>";
  description
    "This YANG module defines a model for network inventory software
     extensions.

     Copyright (c) 2024 IETF Trust and the persons
     identified as authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject
     to the license terms contained in, the Revised BSD License
     set forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX; see
     the RFC itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL', 'SHALL
     NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED', 'NOT RECOMMENDED',
     'MAY', and 'OPTIONAL' in this document are to be interpreted as
     described in BCP 14 (RFC 2119) (RFC 8174) when, and only when,
     they appear in all capitals, as shown here.";

  revision 2024-10-17 {
    description
      "Initial version";
    reference
      "RFC XXXX: A YANG Data Model for Network Inventory Software
                 Extensions.";
  }

  identity ne-nonphysical {
    base nwi:ne-type;
    description
      "A non-physical network element (NE) is a network device that
       support network protocols and functions, e.g., router,
       firewall, and controller, which can reside in any network or
       compute devices, such as a server in Data Center (DC),
       server-based virtual machine (VM), or server-based container.";
  }

  identity ne-software {
    base ne-nonphysical;
    description
      "A software NE refers to a a network device residing in any
       network or compute devices, such as a physical server
       (or 'bare metal') in DC. Examples of software NEs are
       network controllers.";
  }

  identity ne-virtual {
    base ne-nonphysical;
    description
      "A virtual NE refers to a network device residing within
       server-based Virtual Machine (VM) implementing a virtual
       network function (VNF). Examples of virtual NEs are
       virtual routers, virtual firewalls.";
  }

  identity ne-container {
    base ne-nonphysical;
    description
      "A container NE refers to a network device residing within
       server-based container implementing a Containerized
       network function (CNF).";
  }

  identity software-component {
    base nwi:non-hardware-component-class;
    description
      "Base identity for software components in a managed
       device.";
  }

  identity operating-system {
    base software-component;
    description
      "OS software type.";
  }

  identity operating-system-patch {
    base software-component;
    description
      "An operating system update - which should be a subcomponent
       of the `operating-system` running on a component. A patch is
       defined to be a set of software changes that are atomically
       installed (and uninstalled) together. ";
  }

  identity bios {
    base software-component;
    description
      "Legacy BIOS or UEFI firmware interface responsible for
       initializing hardware components and first stage boot
       loader.";
  }

  identity boot-loader {
    base software-component;
    description
      "Software layer responsible for loading and booting the
       device OS or network OS.";
  }

  identity software-module {
    base software-component;
    description
      "A base identity for software modules installed and/or
       running on the device.  Modules include user-space programs
       and kernel modules that provide specific functionality.";
  }

  identity software-status {
    description
      "Base identity for software status.";
  }

  identity software-installed {
    base software-status;
    description
      "Software status is Installed.";
  }

  identity software-activated {
    base software-status;
    description
      "Software status is Activated.";
  }

  grouping software-info-grouping {
    description
      "Specific attributes applicable to Software.";
    leaf status {
      type identityref {
        base software-status;
      }
      description
        "Software status.";
    }
    leaf installation-time {
      type yang:date-and-time;
      description
        "Date and time the current revision last changed.";
    }
    leaf activation-time {
      type yang:date-and-time;
      description
        "Date and time the current revision last changed.";
    }
  }

  /* Main blocks */

  augment "/nwi:network-inventory/nwi:network-elements"
        + "/nwi:network-element" {
    description
      "Augment network element (NE) attributes.";
    container software-attributes {
      when "derived-from-or-self(../nwi:ne-type,'ne-software')";
      config false;
      description
        "Container for the attributes applicable only to software
         Network Elements (NEs).";
      uses software-info-grouping;
    }
  }

  augment "/nwi:network-inventory/nwi:network-elements/"
        + "nwi:network-element/nwi:components/nwi:component" {
    description
      "Augment software component attributes.";
    container software-module-attributes {
      when
        "derived-from-or-self(../nwi:class,'software-module')";
      config false;
      description
        "This container contains some attributes belong to
         software modules only.";
      uses software-info-grouping;
    }
  }
}

<CODE ENDS>

Security Considerations
The YANG module specified in this document defines a data schema designed to be accessed through network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the required secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the required secure transport is TLS [RFC8446].
The Network Configuration Access Control Model (NACM) [RFC8341] provides a means of restricting access to specific NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and contents. Thus, NACM SHOULD be used to restrict the NSF registration from unauthorized users.
There are a number of data nodes defined in this YANG module that are writable, creatable, and deletable (i.e., config true, which is the default). These data nodes may be considered sensitive or vulnerable in some network environments. Write operations to these data nodes could have a negative effect on network and security operations.
Some of the readable data nodes in this YANG module may be considered sensitive or vulnerable in some network environments. It is thus important to control read access (e.g., via get, get-config, or notification) to these data nodes. These are the subtrees and data nodes and their sensitivity/vulnerability:
<<<to be completed>>>

IANA Considerations
This document registers a URI in the "IETF XML Registry" [RFC3688]. Following the format in [RFC3688], the following registration has been made.
     URI: urn:ietf:params:xml:ns:yang:ietf-network-inventory-sw-ext
     Registrant Contact: The IESG.
     XML: N/A, the requested URI is an XML namespace.
This document registers a YANG module in the "YANG Module Names" registry[RFC7950] .
     Name:         ietf-network-inventory-sw-ext
     Namespace:    urn:ietf:params:xml:ns:yang:ietf-network-inventory-sw-ext
     Prefix:       nwis
     Maintained by IANA? N
     Reference:    RFC xxxx

Acknowledgements
The authors wish to thank Prasenjit Manna,Phil Bedard, Diego R. Lopez, Italo Busi, and many others for their helpful comments and suggestions.

Normative References

Informative References
[I-D.ietf-ivy-network-inventory-yang]
[RFC8309]
[RFC8342]
[RFC2119]
[RFC8174]
[RFC8340]
[RFC3688]
[RFC7950]